
      .386
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

;**********************************************************************

;     include files
;     ~~~~~~~~~~~~~
      include \Altra32\INCLUDE\windows.inc
      include \Altra32\INCLUDE\user32.inc
      include \Altra32\INCLUDE\kernel32.inc
      include \Altra32\INCLUDE\gdi32.inc
      include \Altra32\INCLUDE\comdlg32.inc


;     libraries
;     ~~~~~~~~~

      includelib \Altra32\LIB\user32.lib
      includelib \Altra32\LIB\kernel32.lib
      includelib \Altra32\LIB\gdi32.lib
      includelib \Altra32\LIB\comdlg32.lib
;**********************************************************************

        ;=================
        ; Local prototypes
        ;=================
        WinMain                 PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WndProc                 PROTO :DWORD,:DWORD,:DWORD,:DWORD
        wsprintfA               PROTO C :DWORD,:VARARG
        wsprintf equ <wsprintfA>
        CreateButton            PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

      ;=============
      ; Local macros
      ;=============

      szText MACRO Name, Text:VARARG
        LOCAL lbl
          jmp lbl
            Name db Text,0
          lbl:
        ENDM

      m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

      return MACRO arg
        mov eax, arg
        ret
      ENDM


.const
;Place all your Constance here.

.data
hWnd             dd 0
hInstance        dd 0
AppName          db "Hello",0
szClassName      db "Template_Class",0
hIcon            dd 0
Wwidth           dd 285
Wheight          dd 180
CommandLine      dd 0
hFont            dd 0
hFont1           dd 0

CapFont   LOGFONT <-8,0,0,0,FW_BOLD,FALSE,FALSE,0,0,0,0,0,0,"Courier"> 
CapFont1   LOGFONT <-13,0,0,0,FW_LIGHT,FALSE,FALSE,0,0,0,0,0,0,"Courier"> 

.data?
;Place your uninitialized data here.


;**********************************************************************
.code

start:
      invoke GetModuleHandle, NULL
      mov hInstance, eax

      invoke CreateFontIndirect,OFFSET CapFont 
      mov hFont,eax 
      invoke CreateFontIndirect,OFFSET CapFont1 
      mov hFont1,eax 

      invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
      invoke ExitProcess,eax

;**********************************************************************


WinMain proc hInst     :DWORD,
             hPrevInst :DWORD,
             CmdLine   :DWORD,
             CmdShow   :DWORD


      ;====================
      ; Put LOCALs on stack
      ;====================

      LOCAL wc   :WNDCLASSEX
      LOCAL msg  :MSG

      ;==================================================
      ; Fill WNDCLASSEX structure with required variables
      ;==================================================

      invoke LoadIcon,hInst,500    ; icon ID
      mov hIcon, eax

      mov wc.cbSize, sizeof WNDCLASSEX
      mov wc.style, CS_HREDRAW or CS_VREDRAW \
                    or CS_BYTEALIGNWINDOW
      mov wc.lpfnWndProc, offset WndProc
      mov wc.cbClsExtra,NULL
      mov wc.cbWndExtra,NULL
      m2m wc.hInstance, hInst
      mov wc.hbrBackground,COLOR_BTNFACE+1
      mov wc.lpszMenuName,NULL
      mov wc.lpszClassName, offset szClassName
      m2m wc.hIcon, hIcon
      invoke LoadCursor,NULL,IDC_ARROW
      mov wc.hCursor, eax
      m2m wc.hIconSm, hIcon

      invoke RegisterClassEx, addr wc


      invoke CreateWindowEx,WS_EX_LEFT,
                              addr szClassName,
                              0,
                              WS_SYSMENU or WS_VISIBLE or DS_MODALFRAME,
                              10,10,Wwidth,Wheight,
                              NULL,NULL,
                              hInst,NULL
      mov hWnd,eax
      invoke ShowWindow,hWnd,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd

      ;===================================
      ; Loop until PostQuitMessage is sent
      ;===================================

    StartLoop:
      invoke GetMessage,addr msg,NULL,0,0
      cmp eax,0
      je ExitLoop
      invoke TranslateMessage, addr msg
      invoke DispatchMessage,  addr msg
      jmp StartLoop
    ExitLoop:

      return msg.wParam

WinMain endp

;**********************************************************************
WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

   LOCAL hDC        :DWORD 
   LOCAL rect       :RECT 
   LOCAL rect2      :RECT 
   LOCAL sizex      :DWORD 
   LOCAL sizey      :DWORD 
   LOCAL junkx      :DWORD 
   LOCAL junky      :DWORD 


         .if uMsg == WM_CREATE
     szText szButtonText0,"Close"
     invoke CreateButton,hWin,196,10,73,24,addr szButtonText0,3000,WS_EX_CLIENTEDGE
     push eax
     invoke SendMessage,eax,WM_SETFONT,hFont1,TRUE
     pop eax
     invoke SetFocus,eax

         .elseif uMsg == WM_COMMAND
       .if wParam == 3000
      invoke PostQuitMessage,NULL
      return 0
       .endif

   .ELSEIF uMsg == WM_NCACTIVATE 
   ;   .IF wParam == FALSE 
   ;      invoke DefWindowProc,hWin,uMsg,wParam,lParam 
   ;      ; Add code here to draw caption when window is inactive. 
   ;      ; or just let it fall through to draw it normally 
   ;      mov eax,TRUE 
   ;      ret 
   ;   .endif 
   ;   ; Fall through if wParam == TRUE, i.e., window is active. 
      jmp @F 

   .ELSEIF uMsg == WM_NCPAINT 
      ; Call the def window proc to draw the frame etc... 
      @@:invoke DefWindowProc,hWin,uMsg,wParam,lParam 
      invoke GetWindowDC,hWin 
      mov hDC,eax 

      ; Get the window dimensions 
      invoke GetWindowRect,hWin, ADDR rect2 

      ; Get the size of the area to draw into 
      invoke GetSystemMetrics,SM_CXSIZE 
      mov sizex,eax 
      invoke GetSystemMetrics,SM_CXBORDER 
      add sizex,eax 
      invoke GetSystemMetrics,SM_CXFRAME 
      mov junkx, eax 
      add sizex,eax 

      mov eax,sizex 
      add eax,1
      mov rect.left,eax 

      invoke GetSystemMetrics,SM_CYFRAME 
      mov sizey,eax 
      mov rect.top,eax 

      ; Fill a RECT structure with our sizes 
      mov eax,rect2.right 
      sub eax,rect2.left 
      shl sizex,1
      sub eax,sizex 
      sub eax,junkx 
      mov rect.right,eax 

      invoke GetSystemMetrics,SM_CYSIZE 
      add eax,sizey
      mov rect.bottom,eax 

      ; Set our font, text colour and draw it transparently in case of a gradient caption 
      invoke SetBkMode,hDC,TRANSPARENT 
      invoke SetTextColor,hDC,0000FFFFh 
      invoke SelectObject,hDC,hFont 
      push eax 
      invoke DrawText,hDC,OFFSET AppName,-1,ADDR rect,DT_LEFT 
      pop eax 
      invoke SelectObject,hDC,eax 
      invoke ReleaseDC,hWin, hDC 
      return 1

         .elseif uMsg == WM_DESTROY
      invoke PostQuitMessage,NULL
      return 0

      .endif

            invoke DefWindowProc,hWin,uMsg,wParam,lParam
            ret
WndProc endp


;*******************************************************************
;
;
;*******************************************************************
CreateButton proc hWin:DWORD,Xpos:DWORD,Ypos:DWORD,Xsize:DWORD,
                  Ysize:DWORD,lpButtonText:DWORD,ID:DWORD,EXStyle:DWORD

                  LOCAL hModule    :DWORD

             szText ButtonClass,"BUTTON"
             invoke GetModuleHandle,NULL
             mov [hModule],eax
             mov eax,EXStyle
             invoke CreateWindowEx,eax,
                                   addr ButtonClass,lpButtonText,
                                   WS_CHILD OR WS_VISIBLE ,
                                   Xpos,Ypos,Xsize,Ysize,hWin,ID,
                                   hModule,NULL
             ret

CreateButton endp

end start

